<template>
  <div class="mb-2">
    <div class="form-check">
      <input
        :type="field.type"
        :id="fieldPrefix + field.name"
        class="form-check-input"
        v-model="fieldValue"
        :disabled="field.disabled || busy"
        @input="onCheckboxInput"
        @keyup.enter="onInput"
      />
      <label class="form-check-label" :for="fieldPrefix + field.name" v-if="field.label">
        {{ field.label }}
        <RequiredIcon v-if="isRequired" />
        <InfoTooltip v-if="field.tooltip" :text="field.tooltip" />
      </label>
    </div>
    <div class="text-danger" v-if="error">{{ error }}</div>
  </div>
</template>

<script>
import { useVFormControl } from '../../plugins/vform-plugin.js'
import InfoTooltip from '../info-tooltip.vue'
import RequiredIcon from '../required-icon.vue'

export default {
  name: 'VFormCheckbox',
  emits: ['input', 'fieldInput'],
  props: {
    formName: { type: String, required: true },
    field: { type: Object, required: true },
    fieldPrefix: { type: String, required: true },
    modelState: { type: Object, default: null }, // Taken from the API response if validation fails at the server.
    busy: { type: Boolean, default: false },
  },
  components: {
    InfoTooltip,
    RequiredIcon,
  },
  setup(props, context) {
    const baseProperties = useVFormControl(props, context)

    const onCheckboxInput = (e) => {
      const mutatedField = JSON.parse(JSON.stringify(props.field))
      mutatedField.value = e.target.checked
      context.emit('input', e)
      context.emit('fieldInput', mutatedField)
    }

    return {
      ...baseProperties,
      onCheckboxInput,
    }
  },
}
</script>
